/*
    Demo1.c : An example of S5.Library usage.

    Paul Richards
    Sophus Software
    11th August 1987

Function:
    
Operates as a CLI command,  where the parameter list contains filenames
of IFF/SOP2 files to be played.

e.g.

Demo1  fx/aardvark  fx/plop  fx/raspberry

*/

#include   "exec/types.h"
#include   "s5.h"
#include   "lattice/stdio.h"

long *S5Base; /* or any pointer type */
int  Success;

main(argc,argv)
int    argc;
char  *argv[];
{
int np;
if(argc < 2)
    {
    /* there must be at least one parameter */
    printf("Usage : Demo1 <filename> <filename> <filename> ....\n");
    exit(-1);
    }
if( (S5Base = (long *)OpenLibrary(S5NAME,0))==0 )
    {
    printf("Failed to open %s\n",S5NAME);
    exit(-2);
    }
np = 1;
while(np<argc)
    {
    Success = S5Player(argv[np]);
    if(Success!=E_OK)
         {
         /* an error, but it might not be our fault */
         printf("Error using file : %s : ",argv[np]);
         switch(Success)
              {
              case E_MEM:    printf("Insufficient memory\n"); break;
              case E_PORT:   printf("Unable to create ports\n"); break;
              case E_DEV:    printf("Unable to access audio device\n"); break;
              case E_FORMAT: printf("File format error\n"); break;
              case E_OPEN:   printf("Unable to open file\n"); break;
              default:       printf("Unspecified error\n"); break;
              }
         }
    np++;
    }
CloseLibrary(S5Base);
}

