/****************************************************************************
*****                                                                    *****
*****                  S5.H  Header for S5                               *****
*****                                                                    *****
*****      \amiga\paul\s5.h  20-August-1987  18:00  PAR                  *****
*****                                                                    *****
******************************************************************************



*/


#define S5NAME "s5.library"
#define S5VERSION    1  /* library version */
#define S5REVISION   1  /* library revision */


#define  ENVMAX    32000 /* maximum value for an envelop point */
#define  DEFAULT_INTERVALS 100 /* default number of segments in an envelope */


struct EnvPnt
    {
    struct EnvPnt *Next;  /* continue to next point. NB x(n)>=x(n-1) */
    USHORT    EnvX,EnvY;  /* actual values. ranging from 0000 to ENVMAX */
    };


struct Envelope
    {
    struct EnvPnt *First; /* 1st in a chain */
    int    EnvPnts;       /* number of points in a chain */
    int    Intervals;     /* how many places to fragment */
    int    Enable;        /* switched on or off */
    USHORT *Table;        /* data table */
    };


struct   Frag
    {
    BOOL  Fr_playenable;
    BOOL  Fr_sampenable;
    BOOL  Fr_playing;          /* whether or not a fragment is playing */
    BOOL  Fr_fastmem;          /* whether chip (0) or fast (1) memory */
    SHORT Fr_side;             /* prefered side, left(0) or right(1) */
    SHORT Fr_volume;
    int   Fr_playticks;        /* hardware tick counter */
    int   Fr_playHz;           /* desired play frequency */
    int   Fr_sampHz;           /* desired sample frequency */
    int   Fr_sampticks_stereo; /* software timer ticks */
    int   Fr_sampticks_mono;   /* software timer ticks */
    long  Fr_cursor;       
    long  Fr_start;            /* start of a block */
    long  Fr_finish;           /* end of a block */
    long  Fr_viewlo;           /* 1st element of displayed graph */
    long  Fr_viewhi;           /* last+1 element of displayed graph */
    int   Fr_repeats;
    APTR  Fr_buffer;           /* OVERALL BUFFER */
    long  Fr_buffsize;
    char  *Fr_name;            /* text area to define a channel */
    struct Envelope *Fr_VolumeEnv;
    struct Envelope *Fr_PeriodEnv;
    APTR  Fr_IOA;              /* IOAudio structure */
    APTR  Fr_res1;             /* reserved for expansion */
    APTR  Fr_res2;
    APTR  Fr_res3;
    };


#define  FRAG_CHIP      0
#define  FRAG_FAST      1


/* standard errors */

#define  E_OK      (0)   /* no error */
#define  E_MEM     (-1)  /* memory error */
#define  E_PORT    (-2)  /* port error */
#define  E_DEV     (-3)  /* device error */
#define  E_OPEN    (-4)  /* file open error */
#define  E_CLOSE   (-5)  /* file close error */
#define  E_READ    (-6)  /* file read error */
#define  E_WRITE   (-7)  /* file write error */
#define  E_FORMAT  (-8)  /* unacceptable value in read data */
#define  E_OKNULL  (-9)  /* Not a serious error - operation had no effect */

/**************************************************************************
******                    END OF S5.H                             *********
**************************************************************************/

